-- Advanced Functional Programming course 2017 Chalmers/GU
--
-- 2017-02-23 Guest lecture by Andreas Abel
--
-- Introduction to Agda
--
-- File 5: Inductive relations

{-# OPTIONS --allow-unsolved-metas #-}

module Le where

open import Data.Nat.Base using (ℕ; zero; suc)
open import Logic

-- We can define our own propositions as we can define data types.

-- The less-or-equal-than relation on natural numbers n ≤ m
-- is given as the smallest relation closed under the following
-- two rules:

data _≤_ : (n m : ℕ) → prop where
  z≤  : ∀{m}               → zero ≤ m
  s≤s : ∀{n m} (p : n ≤ m) → suc n ≤ suc m

-- n ≤ m is a dependent type.
-- Which derivations inhabit it depends on the values of n and m

-- Example derivation:

1≤3 : 1 ≤ 3
1≤3 = {!!}

¬1≤0 : ¬ (1 ≤ 0)
¬1≤0 = {!!}

-- Theorem : n ≤ n
-- By induction on n

≤refl : ∀ n → n ≤ n
≤refl = {!!}

-- Theorem: ≤ is transitive
-- By induction on the two derivations.

≤trans : ∀ {n m k} (p : n ≤ m) (q : m ≤ k) → n ≤ k
≤trans = {!!}

-- Theorem: ≤ is total
-- By induction on n and cases on m

≤total : ∀ n m → (n ≤ m) ∨ (m ≤ n)
≤total = {!!}
