-- Advanced Functional Programming course 2017 Chalmers/GU
--
-- 2017-02-23 Guest lecture by Andreas Abel
--
-- Introduction to Agda
--
-- File 3: insertion sort preserves length, proved using equality chains

{-# OPTIONS --allow-unsolved-metas #-}

module LengthIsortChain where

open import InsertionSortBool
open import Relation.Binary.PropositionalEquality

-- ≡-Reasoning gives us a defined (!) notation to write equality chains.

open ≡-Reasoning

-- Lemma: insertion increases the length of a list by one.
-- Proof by induction on ys.

length-insert : ∀ x ys → length (insert x ys) ≡ suc (length ys)

-- Case: empty list
length-insert x [] = {!!}

-- Case: cons list (y ∷ ys)
length-insert x (y ∷ ys) with x <= y

-- Subcase: x <= y is true
... | true  = {!!}

-- Subcase: x <= y is false
... | false = {!!}


-- Theorem: sorting preserves the length
-- By induction on the xs.

length-isort : ∀ xs → length (isort xs) ≡ length xs

-- Case: empty list
length-isort [] = {!!}

-- Case: cons list (x ∷ xs)
length-isort (x ∷ xs) = begin
  length (isort (x ∷ xs))       ≡⟨ {!!} ⟩
  length (insert x (isort xs))  ≡⟨ {!!} ⟩
  suc (length (isort xs))       ≡⟨ {!!} ⟩
  suc (length xs)               ≡⟨ {!!} ⟩
  length (x ∷ xs)
  ∎
